'repeater3.vbs - 3rd version of a simple script to activate PTT when incoming carrier present
' - This is needed if we want to run like a repeater and feed incoming audio from receiver
' - back to the transmitter. Remember to not mute microphone/line audio on the playback volume controls
' - as this sets the volume for transmit
' - NOTE: The box Key PTT on local Transmit in the TX Ctrl SysOP tab must be enabled
' - NOTE: This version seems to require using real COS signal for receive indication (Not VOX)

'Author: Mike Grenier, KC0IOC
'Date: Dec 21, 2003

'To invoke this script from the command line, type:
'	cscript repeater3.vbs

' Modify the next statement to set the tail timer in milliseconds
tailtimer=2000

' looprate sets the rate we poll the EchoLink system in milliseconds
looprate = 100  

'Instantiate EchoLink's Session component, and set up an event connection

Set oEchoLink = WScript.CreateObject("EchoLink.EchoLinkSession", "EchoLink_")
WScript.Echo "Connection to Echolink Object established"	

carrier = 0
myptt = 0  ' This is true whenever our script is activating the PTT on the transmitter

While True
	'WScript.Echo "Carrier = " & carrier & ", myptt = " & myptt & ", ptt = " & oEchoLink.PTT & ", netaudio = " & oEcholink.Receiving
	If carrier and not oEchoLink.PTT Then
		WScript.Echo "Activating PTT"
		oEchoLink.PTTControl true
		myptt = 1
	End If

	If not carrier and myptt and Not oEchoLink.Receiving then
		ltimer = ltimer + looprate

		' Turn off PTT if tail timer has expired
		if ltimer > tailtimer then 
			WScript.Echo "Deactivating PTT"
			oEchoLink.PTTControl false
			myptt = 0
			ltimer = 0
		End If
	End IF

	WScript.Sleep looprate
Wend


Sub EchoLink_Closing
	'EchoLink is shutting down; exit now 
	WScript.Echo "EchoLink exiting"
	Set oEchoLink = Nothing
	WScript.Quit(0)
End Sub

Sub Echolink_CarrierDetect(bCD)
	WScript.Echo "Event: CD = " & bCD
	carrier = bCD
	ltimer = 0 'Clear tail timer on change of RF signal
End Sub

Sub Echolink_PTT(bPTT)
	WScript.Echo "Event: PTT = " & bPTT
	ltimer = 0 'Clear tail timer on change of PTT
End Sub

